#/******************************************************************************
#*                              __fixsfsi
#*******************************************************************************
#* Convert a floating point value to signed 32-bit representation 
#*
#* Inputs:  [R1,R2] - 32-bit float
#*
#* Returns: [R1,R2] - 32-bit signed integer
#*
#* Clobbers: 0,1,2
#******************************************************************************/
  def __fixsfsi
  even
__fixsfsi:
  mov r1, r1
  jlt fixs_neg
  b @__fixunsfsi
fixs_neg:

  # Value is negative, apply sign after conversion
  dect r10
  mov  r11, *r10
  andi r1, 0x7FFF
  bl @__fixunsfsi

  # Negate integer value
  inv r1
  neg r2
  jnc fixs_done
  inc r1
fixs_done

  mov *r10+, r11
  b *r11

