#/******************************************************************************
#*                              __fixunsfsi
#*******************************************************************************
#* Convert a floating point value to unsigned 32-bit representation 
#*
#* Inputs:  [R1,R2] - 32-bit float
#*
#* Returns: [R1,R2] - 32-bit unsigned integer
#*
#* Clobbers: 0,1,2
#******************************************************************************/
  def __fixunsfsi
__fixunsfsi:
  mov r1, r0
  jlt fixu_zero   # Value is negative, cannot convert, return zero

  # Isolate exponent
  sla r0, 1
  swpb r0
  sb r0, r0
  ai r0, -127
  jlt fixu_zero  # Value is zero or denormal
  ci r0, 31
  jgt fixu_zero  # Value is infinite
  ori r1, 0x0080
  sb r1, r1
  ai r0, -23
  jeq fixu_done
  jlt fixu_right
  b @__shiftl_32
fixu_right:
  neg r0
  b @__shiftr_32
fixu_zero:
  clr r1
  clr r2
fixu_done:  
  b *r11

