#/******************************************************************************
#*                              __floatsisf
#*******************************************************************************
#* Convert an signed 32-bit value to floating point representation 
#*
#* Inputs:  [R1,R2] - 32-bit integer
#*
#* Returns: [R1,R2] - 32-bit float
#* 
#* Clobbers: 1,2,3
#******************************************************************************/
  def __floatsisf
  even
__floatsisf:
  abs r1         # If value was positive, this changes nothing
  jlt negate
  clr r3         # Clear sign bit
  jmp done
negate:
  li r3, 0x8000  # Set sign bit
  neg r2         # Negate low word
  joc done
  dec r1         # If no carry from NEG, undo the +1 from ABS
done:
  b @__floatsisf_common

