#/******************************************************************************
#*                              __floatunsisf
#*******************************************************************************
#* Convert an unsigned 32-bit value to floating point representation 
#*
#* Inputs:  [R1,R2] - 32-bit integer
#*
#* Returns: [R1,R2] - 32-bit float
#* 
#* Clobbers: 1,2,3,4,5,6,7,12
#******************************************************************************/
  def __floatunsisf
  even
__floatunsisf:
  clr r3
#  /* Fall through to __floatsisf_common */


#/******************************************************************************
#*                              __floatsisf_common
#*******************************************************************************
#* Convert an signed 32-bit value to floating point representation 
#*
#* Inputs:  [R1,R2] - 32-bit integer
#*           R3     - Sign bit
#*
#* Returns: [R1,R2] - 32-bit float
#* 
#* Clobbers: 1,2,3,4,5,6,7,12
#******************************************************************************/
  def __floatsisf_common
  even
__floatsisf_common:

#  /* Preserve original value */
  mov r1, r4
  jne not_zero_hi
  mov r2, r5
  jne not_zero
  
#  /* If we got here, value is zero */
  clr r1
  clr r2
  b *r11

#  /* If we got here, value is not zero */
not_zero_hi:
  mov r2, r5
not_zero:

#  /* Save return value */  
  dect r10
  mov r11, *r10
  mov r3, r7

#  /* Calculate exponent */
  bl @__clzsi2
  li r6, 31+127
  s r1, r6

#  /* Shift into position */
  mov r1, r0
  mov r4, r1
  mov r5, r2
  ai r0, -8
  jeq  shift_done
  jgt  shift_left

#  /* Shift right */
  neg r0
  bl @__shiftr_32
  jmp  shift_done

shift_left:
  bl @__shiftl_32

shift_done:
  andi r1, 0x007F #/* Mask implicit bit */
  sla  r6, 7
  soc  r6, r1     #/* Add exponent */
  soc  r7, r1     #/* Add sign */
  mov *r10+, r11
  b   *r11

