#/******************************************************************************
#*                              __normalize
#*******************************************************************************
#* Compare two positive floating point values
#*
#* Inputs:  [R1,R2] - 32-bit float
#*           R3     - Exponent
#*
#* Returns: [R1,R2] - 32-bit float
#*
#* Clobbers: 0,1,2,3,4,5
#******************************************************************************/
  def __normalize
  even
__normalize:
  dect r10
  mov r11, *r10 # Save return pointer
  mov r1, r4    # Save value for later
  mov r2, r5
  bl @__clzsi2
  mov r1, r0
  mov r4, r1
  mov r5, r2
  ai r0, -8     # Compute shift count
  mov r0, r4
  jlt norm_right
  jeq norm_done

  # Normalize by shifting left
  bl @__shiftl_32
  jmp norm_done

norm_right:
  # Normalize by shifting right
  neg r0
  bl @__shiftr_32

norm_done:
  andi r1, 0x007F  # Clear implicit bit
  sla r4, 7        # Prepare normalization exponent
  s r4, r3         # Adjust exponent
  mov *r10+, r11   # Restore return pointer
  soc r3, r1       # Apply exponent

  # Check for infinity and denormal
  jlt norm_deninf
  # Result is a normal value
  b *r11
norm_deninf:
  # Check normalization adjustment
  mov r4, r4
  jlt norm_inf
  # Result is a denormal value
  li r1, 0x007F
  seto r2
  b *r11
norm_inf:
  # Result is an infinite value
  li r1, 0x7f80
  clr r2
  b *r11

