#/******************************************************************************
#*                              __shiftl_32
#*******************************************************************************
#* Left shift 32-bit integer by variable amount
#*
#* Inputs:  R0      - Shift count
#*          [R1,R2] - 32-bit integer
#*
#* Returns: [R1,R2] - Shifted result
#* 
#* Clobbers: 0,1,2,12 
#******************************************************************************/
  def __shiftl_32
  even
__shiftl_32:
#  /* Shift left */
  ci r0, 16
  jlt shiftl_short
  jeq shiftl_16

  # /* Shift by more than 16 */
  sla r2, r0
shiftl_16:
  # /* Shift by exactly 16 */
  mov r2, r1
  clr r2
  b *r11

shiftl_short:
  # /* Shift by less than 16 */
  mov r0, r0
  jeq shiftl_done  # /* Shift by zero? do nothing */
  mov r2, r12
  sla r1, r0
  sla r2, r0
  neg r0
  srl r12, r0
  soc r12, r1
shiftl_done:
  b *r11

