#/******************************************************************************
#*                              __shiftr_32
#*******************************************************************************
#* Right shift 32-bit integer by variable amount
#*
#* Inputs:  R0      - Shift count
#*          [R1,R2] - 32-bit integer
#*
#* Returns: [R1,R2] - Shifted result
#* 
#* Clobbers: 0,1,2,12 
#******************************************************************************/
  def __shiftr_32
  even
__shiftr_32:
#  /* Shift right */
  ci r0, 16
  jlt shiftr_short
  jeq shiftr_16

  # /* Shift by more than 16 */
  srl r1, r0
shiftr_16:
  # /* Shift by exactly 16 */
  mov r1, r2
  clr r1
  b *r11

shiftr_short:
  # /* Shift by less than 16 */
  mov r0, r0
  jeq shiftr_done
  mov r1, r12
  srl r1, r0
  srl r2, r0
  neg r0
  sla r12, r0
  soc r12, r2
shiftr_done:
  b *r11

